; TIP1015.LSP: BIGTRIM.LSP   Trim Multiple Lines   (c)1994, Mark H. Miller

(defun C:BIGTRIM ()
   (setq A (getpoint "\nFirst point of cutting line: "))
   (setq B (getpoint A "\nSecond point of cutting line: "))
   (setq SS (ssget))
   (setq D (getpoint "\nSide to trim: "))
   (setq INDEX 0)
   (repeat (sslength SS)
      (if (setq INT (inters A B 
               (setq P1 (cdr (assoc 10 (entget (ssname SS INDEX)))))
               (setq P2 (cdr (assoc 11 (entget (ssname SS INDEX)))))
            )
         )
         ;if d is on same side of line ab as p1, modify p1, or else modify p2
         (if (> (distance D P2)
               (max (distance (setq INT2 (inters A B D P2 nil)) P2)
                  (distance INT2 D)
               )
            )
            (entmod (subst (cons 10 INT)
            (assoc 10 (setq E (entget (ssname SS INDEX))))E))
            (entmod (subst (cons 11 INT)
            (assoc 11 (setq F (entget (ssname SS INDEX))))F))
         )
      )
      (setq INDEX (1+ INDEX))
   )
); end bigtrim.lsp
