; TIP1017.LSP: HALFCIRC.LSP   Hide Half of a Circle   (c)1994, Stan Kowalski

(defun C:HALFCIRC (/ LTYPE ENT ELIST EPICK ETYPE
         CENTER RADIUS ANG BREAK1 BREAK2
         CIRLY CLAYER)
   (setvar "cmdecho" 0)
   (setvar "highlight" 0)
   (if (not (tblsearch "LTYPE" "HIDDEN"))
      (progn
         (command "linetype" "load" "HIDDEN" "" "")
         (setq ltype "HIDDEN")
      )
      (setq ltype "HIDDEN")
   )
   (prompt "Select circle on side you wish to hide")
   (setq ENT (entsel))
   (if ENT
      (progn
         (setq ELIST (entget (car ENT))
            EPICK (osnap (cadr ENT) "NEAR")
            ETYPE (cdr (assoc 0 ELIST))
            CLAYER (getvar "CLAYER")
         )
         (if (= ETYPE "CIRCLE")
            (progn
               (setq CENTER (cdr (assoc 10 elist))
                  RADIUS (cdr (assoc 40 ELIST))
                  EPICK (osnap EPICK "QUAD")
                  ANG (angle CENTER EPICK)
                  CIRLY (cdr (assoc 8 ELIST))
               )
               (cond
                  (  ;right half
                     (= ang 0.0)
                     (setq BREAK1 (polar CENTER (* PI 1.5) RADIUS)
                        BREAK2 (polar CENTER (/ PI 2.0) RADIUS)
                     )
                  )
                  (  ;left half
                     (= ANG PI)
                     (setq BREAK1 (polar CENTER (/ PI 2.0) RADIUS)
                        BREAK2 (polar center (* Pi 1.5) radius)

                     )
                  )

                  (  ;top half
                     (= ANG (/ PI 2.0))
                     (setq BREAK1 (polar CENTER 0.0 RADIUS)
                        BREAK2 (polar CENTER PI RADIUS)
                     )
                  )
                  (  ;bottom half
                     (= ANG (* PI 1.5))
                     (setq BREAK1 (polar CENTER PI RADIUS)
                        BREAK2 (polar CENTER 0.0 RADIUS)
                     )
                  )

               );end cond
               (command "layer" "s" CIRLY "")
               (command "break" EPICK "f" BREAK1 BREAK2)
               (command "arc" BREAK1 "C" CENTER BREAK2)
               (setq ENT (entlast))
               (command "change" ENT "" "PROP" "ltype" LTYPE "")
               (command  "layer" "s" CLAYER "")
            );end progn
            (prompt "\nEntity selected isn't a circle.")
         )
      )
      (prompt "\nMissed!")
   )
   (setvar "cmdecho" 1)
   (setvar "highlight" 1)
   (princ)
);end halfcirc.lsp


